#include "myVector.h"
#include <iostream>
#include <iterator>

MyVector::MyVector(int size, int capacity) : _capacity(capacity) {
	_curr=0;
	_size=size;
	_items=new int[_size];
	for(int i=0;i<_size;++i){
		_items[i]=0;
	}
}

MyVector::MyVector(const MyVector& other) : _capacity(other._capacity) {
	_curr=other._curr;
	_size=other._size;
	_items=new int[_size];
	//for(int i=0;i<_size;++i){_items[i]=other._items[i];}
	std::copy(other._items,other._items+other._size,_items);
}

MyVector& MyVector::operator=(const MyVector& other){
	//nrtkads kivdse (v=v esetn ketrln v-t)
	if(this!=&other){
		//Rgi takartsa
		delete[] _items;
		//j trterlet foglalsa
		_size=other._size;
		_items=new int[_size];
		//Reprezentci msolsa
		_curr=other._curr;
		std::copy(other._items,other._items+other._size,_items);
	}
	//Visszaadjuk magunkat
	return *this;
}

int MyVector::operator[](int index) const{
	return at(index);
}
int& MyVector::operator[](int index){
	return at(index);
}



MyVector::~MyVector(){
	delete[] _items;
	_items=0;//Extra biztonsg, konvenci
}

//Sajt tpuson belli tagfggvnyek ltjk az aktulis objektum reprezentcijt.
void MyVector::prettyPrint() const{
	for(int i=0;i<_size;++i){
		std::cout<<_items[i]<<", ";
	}
	std::cout<<_size<<" items printed. Capacity is "<<_capacity<<std::endl;
}

void MyVector::push_back(const int& e){
	if (_curr>=_capacity){
	throw -1;
	}

	//ToDo: Mi van, ha _capacity szerint mg fr bele, de a _size mr el lett rve.
	//Fogunk egy nagyobb trterletet, tmsoljuk az elemeket, trljk a rgit.

	_items[_curr++]=e;
}

int& MyVector::at(int index){
	return _items[index];
}

int MyVector::at(int index) const{
	return _items[index];
}

std::ostream& operator<<(std::ostream& os, MyVector& v){
	std::copy(v._items,v._items+v._size,std::ostream_iterator<int>(os,", "));
	//vagy
	/*
	for(int i=0;i<v._size;++i){
		os<<v._items[i]<<", ";
	}*/
	return os;
}
