#ifndef MyVector_H //ZH-n ktelez az include guard hasznlata
#define MyVector_H
#include <iostream>
//using namespace std; //ZH-n s egybknt is tilos, mert elrontja a fjlokat, amik include-oljk ezt a headert. (?Ezt minek ismteljk?)

class MyVector{
private: //Ez a default, nem kell/szoks kirni.
	int _size; //Az adattagok eltti alhzs (_) jel konvenci.
	const int _capacity;
	int _curr;
	int* _items;

public:
	MyVector(int size=10, int capacity=100);
	~MyVector();
	MyVector(const MyVector& other);
	MyVector& operator=(const MyVector& other);
	int operator[](int index) const;
	int& operator[](int index);

	void prettyPrint() const;

	int& at(int index);
	int at(int index) const;

	void push_back(const int& e);

	friend std::ostream& operator<<(std::ostream& os, MyVector& v);
};
#endif //MyVector_H
