//Berezvai Dniel
//BEDTACI.ELTE

#include "MyVector.h"
#include <fstream>
#include <iostream>
#include <math.h>
#include <sstream>
#include <stdlib.h>
#include <string>
using namespace std;
int main(){
	cout<<"Calling constructors"<<endl;
	MyVector::MyVector m; //Default konstruktor hvdik.
	MyVector::MyVector v(20, 20);
	MyVector::MyVector v2(30);
	cout<<"Constructors called."<<endl<<endl;

	cout<<"prettyPrint():"<<endl;
	m.prettyPrint();
	v.prettyPrint();
	v2.prettyPrint();
	cout<<endl;

	cout<<"Filling v with push_back():"<<endl;
	for(int i=10;i<50;i+=3){
		v.push_back(i);
	}
	v.prettyPrint();
	cout<<endl;


	cout<<"Custom printing with at():"<<endl;
	cout<<v.at(0)<<", "<<v.at(10)<<", "<<v.at(19)<<endl<<endl;

	cout<<"Creating two copies"<<endl;
	const MyVector::MyVector vCopy(v);
	MyVector::MyVector vCopy2 = v;
	cout<<"Done."<<endl<<endl;

	cout<<"Verifying copies:"<<endl;
	//https://www.google.com/search?q=warning%3A+the+address+of+*+will+never+be+NULL
	vCopy2.push_back(1000);
	v.prettyPrint();
	delete &v; //Deleted original
	vCopy2.prettyPrint(); //Copy still works
	cout<<endl;

	cout<<"Verifying indexing with []:"<<endl;
	v2[3]=1;
	cout<<v2[3]<<" works";
	cout<<endl<<endl;

	cout<<"Verifying printing with <<:"<<endl;
	cout<<vCopy2;
	cout<<endl<<endl;

	return 0;
}
